<?php

namespace Drupal\leadsms_text\Controller;

use Drupal\Component\Utility\Html;
use Drupal\Core\Controller\ControllerBase;
use Http\Client\Exception\RequestException;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

/**
 * Returns responses for LEADsms routes.
 */
final class LeadSmsController extends ControllerBase {

  /**
   * Builds the response.
   */
  public function __invoke(Request $request) {
    // TODO: maybe csrf tokens.
    /*$token = $request->request->get('csrf_token');
    if (!\Drupal::service('csrf_token')->validate($token, 'leadsms_generic_token')) {
      return new JsonResponse([
        'success' => FALSE,
        'message' => 'Invalid token',
      ], 400);
    }*/

    // Check for POST data.
    $form = $request->request->all()['form'] ?? null;
    if ($form) {
      // Sanitize input.
      $sender = isset($form['name']) ? Html::escape($form['name']) : "";
      $phone = isset($form['phone']) ? Html::escape($form['phone']) : "";
      $message = isset($form['message']) ? Html::escape($form['message']) : "";

      if ($sender && $phone && $message) {
        $fromPhone = str_replace(["(", ")", " "], "-", $phone);

        $hostURL = 'https://connectsms.ca';

        try {
          $response = \Drupal::httpClient()
            ->post($hostURL . '/_LEADsms_in_Wrapper.php', [
              'form_params' => [
                'AccountSid' => 'AC23ac30f38763217a1d1c039661015050',
                'AccountID' => \Drupal::config('leadsms_text.settings')->get('license.license_key'),
                'Body' => $message,
                'From' => '+' . $fromPhone,
                'Name' => $sender,
              ],
            ]);

          $body = $response->getBody()->getContents();
          return new JsonResponse(json_decode($body));
        }
        catch (RequestException $e) {
          \Drupal::logger('leadsms_text')->error($e->getMessage());
          return new JsonResponse([
            'success' => FALSE,
            'message' => 'Error sending the message',
          ], 400);
        }
      }
      else {
        return new JsonResponse([
          'success' => FALSE,
          'message' => 'Invalid form',
        ], 400);
      }
    }
    else {
      return new JsonResponse(['success' => FALSE, 'message' => 'Empty form'], 400);
    }
  }

}
